<div class="container-fluid">
  <div class="col-md-12">
    <div class="box">
      <div class="box-header with-border">
        <div class="row">
          <div class="col-sm-8">
            <h3 class="box-title">Transfer Budget</h3>
          </div>
          <div class="col-sm-2">
            <button class="btn btn-success btn-xs fa-pull-right"
                    (click)="downloadSampleDocument()">
              <i class="pi pi-file-excel" style="font-size: 1em;"></i>
              Sample Doc
            </button>
          </div>
          <div class="col-sm-2">
            <button class="btn btn-success btn-xs fa-pull-right" (click)="uploadFile()"> Upload File</button>
          </div>
        </div>
      </div>
      <!-- /.box-header -->
      <div class="box-body" *ngIf="data$">
        <p-table id="exportTable"
                 class="text-left"
                 [columns]="columnName"
                 [value]="(data$)"
                 [resizableColumns]="true"
                 [autoLayout]="true">
          <ng-template pTemplate="caption">
            <div class="row">
              <div class="col-sm-12">
                <span>
                    List of Payment
                :&nbsp;{{ data$.length }}
                </span>
              </div>
            </div>
          </ng-template>
          <ng-template pTemplate="header" let-columns>
            <tr>
              <th *ngFor="let col of columns" [pSortableColumn]="col.value">
                {{col.name}}
                <p-sortIcon [field]="col.value"></p-sortIcon>
              </th>
            </tr>
          </ng-template>

          <ng-template pTemplate="body" let-list let-i="rowIndex">
            <tr [ngStyle]="{'background-color':i%2 === 0 ? '#fafafa' : '#e9ecef'}">
              <td>{{ i + 1 }}</td>
              <td>{{ list.requestedBy}}</td>
              <td>{{ list.assignedTo }}</td>
              <td>{{ list.count}}</td>
              <td>{{ list.remarks }}</td>
              <td>{{ list.transferStatus }}</td>
              <td>
                <span *ngIf="list.requestedByUserId === currentUserId && list.transferStatus !== 'TRANSFERRED'">
                    <p-inputSwitch
                      [name]="list.status"
                      [inputId]="list.status"
                      (onChange)="handleChange($event, list.entryId)"
                      [ngModel]="list.status === 'ACTIVE'? true: false ">
                    </p-inputSwitch>
                </span>
                <span *ngIf="list.requestedByUserId !== currentUserId">{{list.status}}</span>
              </td>
              <td>
                <button class="btn btn-success btn-xs" (click)="confirm(list.entryId)"
                        *ngIf="currentUserId === list.assignedToUserId
                        && list.transferStatus === 'PENDING'">
                  Approve <i class="pi pi-check"></i>
                </button>
                <button class="btn btn-info btn-xs" [routerLink]="['/branch-budget/transfer', list.entryId]">
                  View <i class="pi pi-eye"></i>
                </button>
              </td>
            </tr>
          </ng-template>
        </p-table>
      </div>
      <div class="box-footer">
      </div>
    </div>
  </div>
</div>


<p-dialog [(visible)]="showUploadFilePopUp"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '490px', height: 'auto'}">
  <p-header>
    Upload Budget Transfer File
  </p-header>
  <form [formGroup]="uploadBudgetTransferForm">
    <div class="form-group">
      <label for="file">Choose file<span class="required">*</span></label>
      <input
        id="file"
        style="width: 190px;"
        formControlName="file"
        id="file"
        [ngClass]="{ 'is-invalid': submitted && f.file.errors }"
        type="file"
        (change)="onFileChange($event)">
      <div *ngIf="submitted && f.file.errors" class="invalid-feedback">
        <div *ngIf="f.file.errors.required">File is Required.</div>
      </div>
    </div>
    <div class="form-group">
      <label for="requestedUser">Select Approver<span class="required">*</span></label>
      <select id="requestedUser"
              class="form-control"
              name="requestedUser"
              [ngClass]="{ 'is-invalid': submitted && f.assignedUserId.errors }"
              formControlName="assignedUserId"
              required>
        <option *ngFor="let event of (allUsers); let i = index"
                [ngValue]="(allUsers)[i].userId"
        >{{(allUsers)[i].fullName + ' ( ' + (allUsers)[i].employeeId + ' )'}}</option>
      </select>
      <div *ngIf="submitted && f.assignedUserId.errors" class="invalid-feedback">
        <div *ngIf="f.assignedUserId.errors.required">Approver is Required.</div>
      </div>
    </div>
    <div class="form-group">
      <label for="remarks">Remarks<span class="required">*</span></label>
      <input type="text"
             id="remarks"
             formControlName="remarks"
             class="form-control"
             placeholder="Max length 50 Characters"
             [ngClass]="{ 'is-invalid': submitted && f.remarks.errors }"
             maxlength="50"
             required>
      <div *ngIf="submitted && f.remarks.errors" class="invalid-feedback">
        <div *ngIf="f.remarks.errors.required">Remarks is required</div>
      </div>
    </div>

    <div class="form-group">
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-success btn-xs btn-block" (click)="submitUploadForm()">
            Submit
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-danger btn-xs btn-block" (click)="cancelSubmit()"> Cancel</button>
        </div>
      </div>
    </div>
  </form>
</p-dialog>

<p-confirmDialog header="Confirmation" icon="pi pi-exclamation-triangle"></p-confirmDialog>
